-- Test edit_campsite
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

set search_path to camper, public;

select plan(12);

select has_function('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean']);
select function_lang_is('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'sql');
select function_returns('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'uuid');
select isnt_definer('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean']);
select volatility_is('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'volatile');
select function_privs_are('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'guest', array[]::text[]);
select function_privs_are('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'employee', array[]::text[]);
select function_privs_are('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'edit_campsite', array ['uuid', 'integer', 'text', 'boolean'], 'authenticator', array[]::text[]);

set client_min_messages to warning;
truncate campsite cascade;
truncate campsite_type cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', 'ES', 'EUR', 'ca')
;

insert into campsite_type (campsite_type_id, company_id, name)
values (11, 1, 'Type A')
     , (12, 1, 'Type B')
     , (13, 1, 'Type C')
;

insert into campsite (company_id, campsite_type_id, slug, label, active)
values (1, 11, '87452b88-b48f-48d3-bb6c-0296de64164e', 'A1', true)
     , (1, 12, '9b6370f7-f941-46f2-bc6e-de455675bd0a', 'B1', false)
;

select lives_ok(
	$$ select edit_campsite('87452b88-b48f-48d3-bb6c-0296de64164e', 13, 'C1', false) $$,
	'Should be able to edit the first campsite.'
);

select lives_ok(
	$$ select edit_campsite('9b6370f7-f941-46f2-bc6e-de455675bd0a', 12, 'B2', true) $$,
	'Should be able to edit the second campsite.'
);

select bag_eq(
	$$ select slug::text, campsite_type_id, label, active from campsite $$,
	$$ values ('87452b88-b48f-48d3-bb6c-0296de64164e', 13, 'C1', false)
	        , ('9b6370f7-f941-46f2-bc6e-de455675bd0a', 12, 'B2', true)
	$$,
	'Should have updated all campsites.'
);


select *
from finish();

rollback;
